<?
// Date in the past
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");

// always modified
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");

// HTTP/1.1
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);

// HTTP/1.0
header("Pragma: no-cache");

@ignore_user_abort(true);
@set_time_limit(0);
include ("includes/config.php");
include ("includes/functions.php");
include ("includes/header.php");

// Get key from web browser
$adminkey = $_GET[key];

// Debugging mode?
$debug = isset($_REQUEST['debug']) ? $_REQUEST['debug'] : false;

// Were running from the command line (cron-jobs)
if (php_sapi_name() == 'cli' or !isset($_SERVER['SERVER_PORT']) or !$_SERVER['SERVER_PORT'])  {
	// No password needed when in cli mode.
	$adminkey = $import_adminkey;
	// There is no time limit when running the cli. And no page to reload :)
	$import_reload_after = 0;
}

echo'<table border="0" cellpadding="1" cellspacing="2" width="720">
  <tr>
    <td class="heading" align="center" colspan="2">Importing Latest Log Files</td>
  </tr>';

IF (empty($import_adminkey)) {
	echo'<tr><td class="smheading" align="left" width="150">Error:</td>
	<td class="grey" align="left">No key set in import.php</td>
	</tr></table>';
	include("includes/footer.php");
	return;
}

IF (empty($adminkey)) {
	echo'<tr>
		  <td class="smheading" align="left" width="150">Enter Admin key:</td>
		  <td class="grey" align="left"><form NAME="adminkey" ACTION="import.php">
		  <input TYPE="text" NAME="key" MAXLENGTH="35" SIZE="20" CLASS="searchform">
		  <input TYPE="submit" VALUE="Submit" CLASS="searchformb"></form></td>
		</tr></table>';
	include("includes/footer.php");
	return;
}

IF ($adminkey != $import_adminkey) {
	echo'<tr><td class="smheading" align="left" width="150">Error:</td>
	<td class="grey" align="left">Keys do not match</td>
	</tr></table>';
	include("includes/footer.php");
	return;
}

echo'</table>
	<br>';

$start_time = time();
if ($ftp_use and !isset($_GET['no_ftp'])) include("includes/ftp.php");

$logdir = opendir('logs');

while (false !== ($filename = readdir($logdir)))
{
// Our (self set) timelimit exceeded => reload the page to prevent srcipt abort
	if (!empty($import_reload_after) and $start_time + $import_reload_after <= time()) {
		$target = $PHP_SELF ."?key=". urlencode($adminkey) ."&amp;no_ftp=1&amp;debug=$debug";
		echo '<meta http-equiv="refresh" content="2;URL='. $target .'">';

		echo'<br /><table border="0" cellpadding="1" cellspacing="2" width="720">
		  <tr>
			<td class="heading" align="center" colspan="2">Maximum execution time exeeded; restarting ...</td>
		  </tr>
		  </table>';

		include("includes/footer.php");
		return;
	}

	$oldfilename = $filename;
	$filename = 'logs/' . $filename;
	$backupfilename = 'logs/backup/' . $oldfilename;
	if(substr($filename, strlen($filename) - strlen($import_log_extension)) != $import_log_extension)
	continue;
	if(substr($oldfilename, 0, strlen($import_log_start)) != $import_log_start)
	continue;

	// Create a unique ID
	$uid = str_rand();

	// Check if there are any logs to do ...

	// Create our temp Table

	$sql = "CREATE ". ($import_use_temporary_tables ? 'TEMPORARY ' : '') ."TABLE `uts_temp_$uid` (
	  `id` mediumint(5) NOT NULL,
	  `col0` char(20) NOT NULL default '',
	  `col1` char(120) NOT NULL default '',
	  `col2` char(120) NOT NULL default '',
	  `col3` char(120) NOT NULL default '',
	  `col4` char(120) NOT NULL default '',
	  KEY `part1` (`col1` (20),`col2` (20)),
	  KEY `part2` (`col0` (20),`col1` (20),`col2` (20)),
	  KEY `full` (`col0` (20),`col1` (20),`col2` (20),`col3` (20),`col4` (20))
	) TYPE=". ($import_use_heap_tables ? 'HEAP' : 'MyISAM') .";";

	$result = mysql_query($sql) or die(mysql_error());;
	$id = 0;

	echo'<table class="box" border="0" cellpadding="1" cellspacing="2">
	<tr>
		<td class="smheading" align="center" height="25" width="550" colspan="2">Importing '.$oldfilename.'</td>
  </tr>
  <tr>
	<td class="smheading" align="left" width="350">Creating Temp MySQL Table:</td>
	<td class="grey" align="left" width="200">uts_temp_'.$uid.'</td>
  </tr>
	<tr>
	<td class="smheading" align="left" width="350">Backing Up Log File:</td>';

	// Copy the file to backup folder first
	if (!copy($filename, $backupfilename))
	{
		echo '<td class="grey" align="left" width="200">Failed</td>';
	} else {
		echo '<td class="grey" align="left" width="200">Succeeded</td>';
	}

	echo'
	<tr>
	<td class="smheading" align="left" width="350">Player Data Moved to Temp MySQL:</td>';

	// Create sql for NGLog
	$row = 1;
	$handle = fopen("$filename", "r");

	while (($data = fgets($handle, 5000)) !== FALSE) {
		if ($debug) debug_output('Raw input         ', $data);
		$data = preg_replace('/[\x00]/', '', $data);
		if ($debug) debug_output('After preg_replace', $data);
		$data = explode("\t", $data);

		$num = count($data);
		$row++;
		for ($c=0; $c < 1; $c++) {

			$col0 = addslashes($data[0]);
			$col1 = addslashes($data[1]);
			$col2 = addslashes($data[2]);
			$col3 = addslashes($data[3]);
			$col4 = addslashes($data[4]);

			$col0 = trim($col0, " \n\r");
			$col1 = trim($col1, " \n\r");
			$col2 = trim($col2, " \n\r");
			$col3 = trim($col3, " \n\r");
			$col4 = trim($col4, " \n\r");

			$id++;
	// Get Basic info we want

	// Take The Rest of the Info to the temp MySql Database
			mysql_query("INSERT INTO uts_temp_$uid VALUES ($id, '$col0', '$col1', '$col2', '$col3', '$col4');") or die(mysql_error());
	   }
	}
	fclose($handle);

	echo'<td class="grey" align="left" width="200">Yes</td>
	  </tr>
		<tr>
		<td class="smheading" align="left" width="350">Match Data Created:</td>';

	// Get the match table info

	$qm_time = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'info' AND col2 = 'Absolute_Time'");
	$qm_servername = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'info' AND col2 = 'Server_ServerName'");
	$qm_serverip = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'info' AND col2 = 'True_Server_IP'");
	$qm_serverport = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'info' AND col2 = 'Server_Port'");
	$qm_gamename = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'game' AND col2 = 'GameName'");

	$qm_gamestart = small_query("SELECT col0 FROM uts_temp_$uid WHERE col1 = 'game' AND col2 = 'realstart'");
	$qm_gameend = small_query("SELECT col0 FROM uts_temp_$uid WHERE col1 = 'game_end'");

	$qm_insta = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'game' AND col2 = 'insta'");
	$qm_tournament = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'game' AND col2 = 'TournamentMode'");
	$qm_teamgame = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'game' AND col2 = 'TeamGame'");
	$qm_mapname = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'map' AND col2 = 'Title'");
	$qm_mapfile = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'map' AND col2 = 'Name'");
	$qm_frags = small_query("SELECT SUM(col4) AS frags FROM uts_temp_$uid WHERE col1 = 'stat_player' AND col2 = 'frags'");
	$qm_kills = small_query("SELECT SUM(col4) AS kills FROM uts_temp_$uid WHERE col1 = 'stat_player' AND col2 = 'kills'");
	$qm_suicides = small_query("SELECT SUM(col4) AS suicides FROM uts_temp_$uid WHERE col1 = 'stat_player' AND col2 = 'suicides'");
	$qm_deaths = small_query("SELECT SUM(col4) AS deaths FROM uts_temp_$uid WHERE col1 = 'stat_player' AND col2 = 'deaths'");
	$qm_teamkills = small_query("SELECT SUM(col4) AS teamkills FROM uts_temp_$uid WHERE col1 = 'stat_player' AND col2 = 'teamkills'");

	$qm_playercount = small_count("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'player' AND col2 = 'rename' GROUP BY col3");

	$s_frags = $qm_frags[frags];
	$s_suicides = $qm_suicides[suicides];
	$s_deaths = $qm_deaths[deaths];

	// Add teamkills only if its a team game, else add them to kills total
	IF ($teamgame == "True") {
		$s_kills = $qm_kills[kills];
		$s_teamkills = $qm_teamkills[teamkills];
	} else {
		$s_kills = $qm_kills[kills]+$qm_teamkills[teamkills];
		$s_teamkills = 0;
	}

	// Check if anything happened, if it didnt stop everything now
	IF ($qm_kills[kills] == 0 && $qm_deaths[deaths] == 0 && $qm_playercount < 2) {
		echo'<td class="grey" align="left" width="200">No (Empty Match)</td></tr>';

	} else {

		$sql_mutators = "SELECT col3 FROM uts_temp_$uid WHERE col1 = 'game' AND col2 = 'GameMutator'";
		$q_mutators = mysql_query($sql_mutators);
		while ($r_mutators = mysql_fetch_array($q_mutators)) {
			$qm_mutators .= "".$r_mutators[col3].", ";
		}


		$qm_serveran = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'info' AND col2 = 'Server_AdminName'");
		$qm_serverae = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'info' AND col2 = 'Server_AdminEmail'");
		$qm_serverm1 = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'info' AND col2 = 'Server_MOTDLine1'");
		$qm_serverm2 = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'info' AND col2 = 'Server_MOTDLine2'");
		$qm_serverm3 = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'info' AND col2 = 'Server_MOTDLine3'");
		$qm_serverm4 = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'info' AND col2 = 'Server_MOTDLine4'");

		$qm_gameinfotl = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'game' AND col2 = 'TimeLimit'");
		$qm_gameinfofl = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'game' AND col2 = 'FragLimit'");
		$qm_gameinfogt = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'game' AND col2 = 'GoalTeamScore'");
		$qm_gameinfomp = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'game' AND col2 = 'MaxPlayers'");
		$qm_gameinfoms = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'game' AND col2 = 'MaxSpectators'");
		$qm_gameinfogs = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'game' AND col2 = 'GameSpeed'");
		$qm_gameinfout = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'game' AND col2 = 'UseTranslocator'");
		$qm_gameinfoff = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'game' AND col2 = 'FriendlyFireScale'");
		$qm_gameinfows = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'game' AND col2 = 'WeaponsStay'");

		$gametime = $qm_time[col3];
		$servername = addslashes($qm_servername[col3]);
		$serverip = $qm_serverip[col3];
		$serverport = $qm_serverport[col3];
		$gamename = addslashes($qm_gamename[col3]);
		$servergametime = get_dp($qm_gameend[col0] - $qm_gamestart[col0]);

		$tournament = $qm_tournament[col3];
		$teamgame = $qm_teamgame[col3];
		$mapname = addslashes($qm_mapname[col3]);
		$mapfile = addslashes($qm_mapfile[col3]);

		// Lazy Hack for unknown gametypes
		$unknowngt = substr("$mapfile", 0, 3);	// Gets first 3 characters

		IF ($unknowngt == "JB-") {
			$gamename = "JailBreak";
		}

		// Append insta to game if it was an insta game
		IF ($qm_insta[col3] == "True") { $gameinsta = 1; $gamename = "$gamename (insta)"; } else { $gameinsta = 0; }

		$qm_firstblood = small_query("SELECT col2 FROM uts_temp_$uid WHERE col1 = 'first_blood'");

		$firstblood = addslashes($qm_firstblood[col2]);


		$serverinfo = addslashes("Admin: $qm_serveran[col3]<br />Email: $qm_serverae[col3] <br /><br />
		<u>MOTD</u><br />$qm_serverm1[col3]<br />$qm_serverm2[col3]<br />$qm_serverm3[col3]<br />$qm_serverm4[col3]");


		$gameinfo = addslashes("Time Limit: $qm_gameinfotl[col3]<br />Frag Limit: $qm_gameinfofl[col3]<br />Goal Team Score: $qm_gameinfogt[col3]<br />
		Max Players: $qm_gameinfomp[col3]<br />Max Specs: $qm_gameinfoms[col3]<br />Game Speed: $qm_gameinfogs[col3]<br />
		Translocator: $qm_gameinfout[col3]<br />Friendly Fire: $qm_gameinfoff[col3]<br />Weapon Stay: $qm_gameinfows[col3]<br />");

		// Tidy Up The Info

		$mutators = substr("$qm_mutators", 0, -2);		// remove trailing ,
		$mutators = un_ut($mutators);				// Remove Class and BotPack. etc
		$mutators = addslashes($mutators);

		$gametime = utdate($gametime);

		// Insert Server Info Into Database
		$sql_serverinfo = "INSERT INTO uts_match (id, time, servername, serverip, gamename, gametime, mutators, insta, tournament,
		teamgame, mapname, mapfile, serverinfo, gameinfo, frags, kills, suicides, teamkills, deaths)
		VALUES ('', '$gametime', '$servername', '$serverip:$serverport', '$gamename', '$servergametime', '$mutators', '$gameinsta', '$tournament',
		'$teamgame', '$mapname', '$mapfile', '$serverinfo', '$gameinfo', '$s_frags', '$s_kills', '$s_suicides', '$s_teamkills', '$s_deaths');";

		$q_serverinfo = mysql_query($sql_serverinfo) or die(mysql_error());
		$matchid = mysql_insert_id();			// Get our Match ID

		echo'<td class="grey" align="left" width="200">Yes</td>
		  </tr>';

		// Process Player Stuff

		echo'<tr>
			<td class="smheading" align="left" width="350">Importing Players:</td>
			<td class="grey" align="left" width="200">';

		// Get List of Player IDs and Process What They Have Done
		$sql_player = "SELECT DISTINCT col4 FROM uts_temp_$uid WHERE col1 = 'player' AND col2 = 'rename' AND col4 <> ''";
		$q_player = mysql_query($sql_player) or die(mysql_error());
		while ($r_player = mysql_fetch_array($q_player)) {
			$playerid = $r_player[col4];

		// Are they a Bot
			$r_player1 = small_query("SELECT col4 FROM uts_temp_$uid WHERE col1 = 'player' AND col2 = 'IsABot' AND col3 = $playerid ORDER BY id DESC LIMIT 0,1");
			$playertype = $r_player1[col4];

		// Get players last name used
			$r_player2 = small_query("SELECT col3 FROM uts_temp_$uid WHERE col1 = 'player' AND col2 = 'rename' AND col4 = $playerid ORDER BY id DESC LIMIT 0,1");
			$playername = addslashes($r_player2[col3]);

		// Get players last team
			$r_player3 = small_query("SELECT col4 FROM uts_temp_$uid WHERE col1 = 'player' AND col2 = 'TeamChange' AND col3 = $playerid ORDER BY id DESC LIMIT 0,1");
			$playerteam = $r_player3[col4];

		// If they are not a Bot carry on doing stuff
			IF($playertype != "True") {

				$qc_kills = small_query("SELECT col4 FROM uts_temp_$uid WHERE col1 = 'stat_player' AND col2 = 'kills'AND col3 = $playerid");
				$qc_teamkills = small_query("SELECT col4 FROM uts_temp_$uid WHERE col1 = 'stat_player' AND col2 = 'teamkills' AND col3 = $playerid");
				$qc_deaths = small_query("SELECT col4 FROM uts_temp_$uid WHERE col1 = 'stat_player' AND col2 = 'deaths' AND col3 = $playerid");

				IF ($qc_kills[col4] == 0 && $qc_deaths[col4] == 0 && $qc_teamkills[col4] ==0) {
				} else {

			// Process all the other player information

					include("import/import_playerstuff.php");

			// Get Gametype specific stuff done

					IF ($gamename == "Assault" | $gamename == "Assault (insta)") { include("import/import_ass.php"); }
					IF ($gamename == "Capture the Flag" | $gamename == "Capture the Flag (insta)") { include("import/import_ctf.php"); }
					IF ($gamename == "Domination" | $gamename == "Domination (insta)") { include("import/import_dom.php"); }
					IF ($gamename == "Tournament Team Game" | $gamename == "Tournament Team Game (insta)") { include("import/import_tdm.php"); }

			// Do the rankings

					include("import/import_ranking.php");

					echo''.$playername.' ';
				}
			}
		}

		// Make our kills matrix stuff ...
		include("import/import_killsmatrix.php");

		echo'</td>
			</tr>
			<tr>
			<td class="smheading" align="left" width="350">Updating Rankings:</td>
			<td class="grey" align="left" width="200">Done</td>
			</tr>
			<tr>
			<td class="smheading" align="left" width="350">Combining Duplicate Player Entries:</td>';

		// Combine duplicate player entries ... very intensive :(
		include("import/import_pcleanup.php");

		echo'<td class="grey" align="left" width="200">Done</td>
			</tr>';

		// Check if theres any players left, if none or one delete the match (its possible ...)
		$final_pcount = small_count("SELECT name FROM uts_player WHERE matchid = $matchid GROUP BY name");

		IF ($final_pcount == NULL || $final_pcount == 1) {
			echo'<tr>
				<td class="smheading" align="left" width="350">Deleting Match:</td>
				<td class="grey" align="left" width="200">0 or 1 Player Entries Left</td>
			</tr>';

			$rem_mrecord = "DELETE FROM uts_match WHERE id = $matchid";
			mysql_query($rem_mrecord);
			$rem_precord = "DELETE FROM uts_player WHERE matchid = $matchid";
			mysql_query($rem_srecord);
		}
	}

	// Delete Temp MySQL Table
	$droptable = "DROP TABLE uts_temp_$uid";
	mysql_query($droptable) or die(mysql_error());

		echo'<tr>
		<td class="smheading" align="left" width="350">Deleting Temp MySQL Table:</td>
		<td class="grey" align="left" width="200">uts_temp_'.$uid.'</td>
	  </tr>
	  <tr>
		<td class="" align="center" height="25" width="550" colspan="2"></td>
	  </tr>
	  </table>
	  ';

  // Clear variables

	$asscode = "";
	$assteam = "";
	$asswin = "";
	$avgping = "";
	$data = "";
	$domplayer = "";
	$droptable = "";
	$firstblood = "";
	$gameinfo = "";
	$gameinsta = "";
	$gamename = "";
	$gametime = "";
	$highping = "";
	$unknowngt = "";
	$lowping = "";
	$mapname = "";
	$mapfile = "";
	$matchid = "";
	$mutators = "";
	$num = "";
	$playerid = "";
	$playerfragscnt = "";
	$playername = "";
	$playerecordid = "";
	$playerteam = "";
	$qm_mutators = "";
	$row = 1;
	$servername = "";
	$serverinfo = "";
	$serverip = "";
	$serverport = "";
	$suicidecnt = "";
	$t0info = "";
	$t1info = "";
	$t2info = "";
	$t3info = "";
	$t0score = "";
	$t1score = "";
	$t2score = "";
	$t3score = "";
	$teamgame = "";
	$tournament = "";

// Delete log file
	unlink($filename);
}
// Optimise database
mysql_query("OPTIMIZE TABLE uts_match, uts_player, uts_rank, uts_killsmatrix;") or die(mysql_error());

echo'<br /><table border="0" cellpadding="1" cellspacing="2" width="720">
  <tr>
	<td class="heading" align="center" colspan="2">Import Script Completed</td>
  </tr>
  </table>';

include("includes/footer.php");
?>
