<?
// Change error reporting otherwise zero_out displays errors
error_reporting(0);

// Image Rotation Code
$charimages[] = "char1.jpg";
$charimages[] = "char2.jpg";
$charimages[] = "char3.jpg";
$charimages[] = "char4.jpg";
$charimages[] = "char5.jpg";
$charimages[] = "char6.jpg";
$charimages[] = "char7.jpg";
$charimages[] = "char8.jpg";
$charimages[] = "char9.jpg";
$charimages[] = "char10.jpg";
$charimages[] = "char11.jpg";
$charimages[] = "char12.jpg";
$charimages[] = "char13.jpg";
$charimages[] = "char14.jpg";

srand(microtime() * 1000);
$charimg = $charimages[rand(0, count($charimages)-1)];

// Two letter codes and their correspionding country names
require_once(dirname(__FILE__) .'/countries.php');

// Addslashes if magic_quotes are off
function my_addslashes($data) {
	IF (!get_magic_quotes_gpc()) {
	   $data = addslashes($data);
	}
	return $data;
}

function my_stripslashes($data) {
	IF (!get_magic_quotes_gpc()) {
	   $data = $data;
	} else {
	   $data = stripslashes($data);
	}
	return $data;
}

// Small query
function small_query($query) {
	$sql_small = "$query";
	$q_small = mysql_query($sql_small) or die(mysql_error());
	$r_small = mysql_fetch_array($q_small);
	return $r_small;
}

// Small query count
function small_count($query) {
	$sql_small = "$query";
	$q_small = mysql_query($sql_small) or die(mysql_error());
	$r_small = mysql_num_rows($q_small);
	return $r_small;
}

// uid generator
function str_rand($length = 8, $seeds = 'abcdefghijklmnopqrstuvwxyz0123456789')
{
    $str = '';
    $seeds_count = strlen($seeds);

    // Seed
    list($usec, $sec) = explode(' ', microtime());
    $seed = (float) $sec + ((float) $usec * 100000);
    mt_srand($seed);

    // Generate
    for ($i = 0; $length > $i; $i++) {
        $str .= $seeds{mt_rand(0, $seeds_count - 1)};
    }

    return $str;
}

function zero_out($data) {
	reset($data);
	while (list($key, $value) = each($data)) {
		if ($value == '0') { $value = ''; }
		$data[$key] = "$value";
	}
	return $data;
}

function get_dp($number) {
	$dp = number_format($number, 2, '.', '');
	return ($dp);
}

function sec2min($number) {
	$dp = $number/60;

	$dp = number_format($dp, 2, '.', '');
	return ($dp);
}

function sec2hour($number) {
	$dp = $number/3600;

	$dp = number_format($dp, 2, '.', '');
	return ($dp);
}

function un_ut($name) {
	$gname = str_replace("Botpack.", "", "$name");
	$gname = str_replace("Class ", "", "$gname");
	$gname = str_replace("CTFGame", "Capture The Flag", "$gname");
	$gname = str_replace(".unr", "", "$gname");
	return ($gname);
}

function mdate($date) {
	$hour = substr("$date", 8, 2);
	$minute = substr("$date", 10, 2);
	$second = "00";
	$day = substr("$date", 6, 2);
	$month = substr("$date", 4, 2);
	$year = substr("$date", 0, 4);

	$ourdate = mktime($hour,$minute,$second,$month,$day,$year);

	$ourdate = date('D, M j Y \a\t g:i a', $ourdate);
	return ($ourdate);
}

function mdate2($date) {
	$hour = substr("$date", 8, 2);
	$minute = substr("$date", 10, 2);
	$second = "00";
	$day = substr("$date", 6, 2);
	$month = substr("$date", 4, 2);
	$year = substr("$date", 0, 4);

	$ourdate = mktime($hour,$minute,$second,$month,$day,$year);

	$ourdate = date('Y-m-d g:i a', $ourdate);
	return ($ourdate);
}

function utdate($gametime) {
	$year = substr("$gametime", 0, 4);
	$month = substr("$gametime", 5, 2);
	$day = substr("$gametime", 8, 2);
	$hour = substr("$gametime", 11, 2);
	$minute = substr("$gametime", 14, 2);
	$second = substr("$gametime", 17, 2);

	$gametime = $year . $month . $day . $hour . $minute . $second;
	return ($gametime);
}

// UT Server Query Functions
function GetItemInfo ($itemname, $itemchunks)
{

  $retval = "N/A";
  for ($i = 0; $i < count($itemchunks); $i++) {
     //Found this item

     if (strcasecmp($itemchunks[$i], $itemname) == 0) {
        $retval = $itemchunks[$i+1];

     }
  }

  //Return value
  return  $retval;
}

function GetMinutes($seconds)
{
	$timemins = intval($seconds / 60);
	$timesecs = ($seconds % 60);

	$Reqlength = 2; //Amount of digits we need
	if ($Reqlength-strlen($timemins) > 0) $timemins = str_repeat("0",($Reqlength-strlen($timemins))) . $timemins;
	if ($Reqlength-strlen($timesecs) > 0) $timesecs = str_repeat("0",($Reqlength-strlen($timesecs))) . $timesecs;
	return $timemins . ":" . $timesecs;
}


function FlagImage($country) {
	global $a_countries;
	if (empty($country)) return('');
	if (!file_exists("images/flags/$country.png")) return(''); //18*12
	$countryname = (isset($a_countries[$country])) ? $a_countries[$country] : '';
	return('<img src="images/flags/'. $country .'.png" width="15" height="10" style="border:0;" alt="'. $country .'" title="'. $countryname .'">');
}

function QuoteHintText($text) {
	$search = array('\\', '\'', '(', ')');
	$replace = array('\\\\', '\\\'', '\\(', '\\)');
	return(str_replace($search, $replace, $text));
}


function OverlibPrintHint($name) {
	include(dirname(__FILE__) .'/hints.php');
	if (!isset($hint[$name])) return('');
	$rv  = 'onmouseover="return overlib(\''. QuoteHintText($hint[$name]['text']) .'\', ';
	$rv .= 'CAPTION, \''. QuoteHintText($hint[$name]['caption']) .'\');" ';
	$rv .= 'onmouseout="return nd();"';
	return($rv);
}

function debug_output($desc, $data) {
	echo '<div align="left"><pre>';
	echo $desc .": ";

	$len = strlen($data);
	for ($i = 0; $i < $len; $i++) {
		echo substr($data, $i, 1) .'  ';
	}
	echo "\n";
	echo str_repeat(' ', (strlen($desc) + 2));
	for ($i = 0; $i < $len; $i++) {
		echo ord(substr($data, $i, 1)) .' ';
	}
	echo "</pre></div>";
}

?>
