-- phpMyAdmin SQL Dump
-- version 2.6.0-pl3
-- http://www.phpmyadmin.net
-- 
-- Host: localhost
-- Generation Time: Mar 06, 2005 at 11:52 PM
-- Server version: 4.0.22
-- PHP Version: 4.3.9
-- 
-- Database: `utstats`
-- 

-- --------------------------------------------------------

-- 
-- Table structure for table `uts_ip2country`
-- 

CREATE TABLE `uts_ip2country` (
  `ip_from` int(10) unsigned NOT NULL default '0',
  `ip_to` int(10) unsigned NOT NULL default '0',
  `country` char(2) NOT NULL default ''
) TYPE=MyISAM;

-- --------------------------------------------------------

-- 
-- Table structure for table `uts_match`
-- 

CREATE TABLE `uts_match` (
  `id` mediumint(10) NOT NULL auto_increment,
  `time` varchar(14) default NULL,
  `servername` varchar(100) NOT NULL default '',
  `serverip` varchar(21) NOT NULL default '0',
  `gamename` varchar(100) NOT NULL default '',
  `gametime` float NOT NULL default '0',
  `mutators` longtext NOT NULL,
  `insta` tinyint(1) NOT NULL default '0',
  `tournament` varchar(5) NOT NULL default '',
  `teamgame` varchar(5) NOT NULL default '',
  `mapname` varchar(100) NOT NULL default '',
  `mapfile` varchar(100) NOT NULL default '',
  `serverinfo` longtext NOT NULL,
  `gameinfo` longtext NOT NULL,
  `firstblood` varchar(50) NOT NULL default '0',
  `frags` mediumint(5) NOT NULL default '0',
  `deaths` mediumint(5) NOT NULL default '0',
  `kills` mediumint(5) NOT NULL default '0',
  `suicides` mediumint(5) NOT NULL default '0',
  `teamkills` mediumint(5) NOT NULL default '0',
  `assaultid` varchar(10) NOT NULL default '',
  `ass_att` tinyint(1) NOT NULL default '0',
  `ass_win` tinyint(4) NOT NULL default '0',
  `t0` tinyint(1) NOT NULL default '0',
  `t1` tinyint(1) NOT NULL default '0',
  `t2` tinyint(1) NOT NULL default '0',
  `t3` tinyint(1) NOT NULL default '0',
  `t0score` mediumint(5) NOT NULL default '0',
  `t1score` mediumint(5) NOT NULL default '0',
  `t2score` mediumint(5) NOT NULL default '0',
  `t3score` mediumint(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `id` (`id`,`t0score`,`t1score`,`t2score`,`t3score`),
  KEY `id_2` (`id`,`servername`,`gamename`,`mapname`,`mapfile`),
  KEY `id_3` (`id`,`time`,`gamename`,`mapfile`,`gametime`)
) TYPE=MyISAM AUTO_INCREMENT=3 ;

-- --------------------------------------------------------

-- 
-- Table structure for table `uts_player`
-- 

CREATE TABLE `uts_player` (
  `id` mediumint(10) NOT NULL auto_increment,
  `matchid` mediumint(10) NOT NULL default '0',
  `insta` tinyint(1) NOT NULL default '0',
  `playerid` tinyint(3) NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  `team` tinyint(2) NOT NULL default '0',
  `isabot` tinyint(1) NOT NULL default '0',
  `country` char(2) NOT NULL default '',
  `ip` varchar(15) NOT NULL default '',
  `gamename` varchar(100) NOT NULL default '',
  `gametime` float NOT NULL default '0',
  `gamescore` mediumint(5) NOT NULL default '0',
  `lowping` mediumint(5) NOT NULL default '0',
  `highping` mediumint(5) NOT NULL default '0',
  `avgping` mediumint(5) NOT NULL default '0',
  `frags` mediumint(5) NOT NULL default '0',
  `deaths` mediumint(5) NOT NULL default '0',
  `kills` mediumint(5) NOT NULL default '0',
  `suicides` mediumint(5) NOT NULL default '0',
  `teamkills` mediumint(5) NOT NULL default '0',
  `eff` float NOT NULL default '0',
  `accuracy` float NOT NULL default '0',
  `ttl` float NOT NULL default '0',
  `flag_taken` mediumint(5) NOT NULL default '0',
  `flag_dropped` mediumint(5) NOT NULL default '0',
  `flag_return` mediumint(5) NOT NULL default '0',
  `flag_capture` mediumint(5) NOT NULL default '0',
  `flag_cover` mediumint(5) NOT NULL default '0',
  `flag_seal` mediumint(5) NOT NULL default '0',
  `flag_assist` mediumint(5) NOT NULL default '0',
  `flag_kill` mediumint(5) NOT NULL default '0',
  `flag_pickedup` mediumint(5) NOT NULL default '0',
  `dom_cp` mediumint(5) NOT NULL default '0',
  `ass_obj` mediumint(5) NOT NULL default '0',
  `wep_trans` mediumint(5) NOT NULL default '0',
  `wep_impact` mediumint(5) NOT NULL default '0',
  `wep_enforcer` mediumint(5) NOT NULL default '0',
  `wep_dblenf` mediumint(5) NOT NULL default '0',
  `wep_bio` mediumint(5) NOT NULL default '0',
  `wep_ripper` mediumint(5) NOT NULL default '0',
  `wep_shock` mediumint(5) NOT NULL default '0',
  `wep_pulse` mediumint(5) NOT NULL default '0',
  `wep_mini` mediumint(5) NOT NULL default '0',
  `wep_flak` mediumint(5) NOT NULL default '0',
  `wep_rock` mediumint(5) NOT NULL default '0',
  `wep_sniper` mediumint(5) NOT NULL default '0',
  `wep_deemer` mediumint(5) NOT NULL default '0',
  `wep_insta` mediumint(5) NOT NULL default '0',
  `spree_double` mediumint(5) NOT NULL default '0',
  `spree_triple` mediumint(5) NOT NULL default '0',
  `spree_multi` mediumint(5) NOT NULL default '0',
  `spree_mega` mediumint(5) NOT NULL default '0',
  `spree_ultra` mediumint(5) NOT NULL default '0',
  `spree_monster` mediumint(5) NOT NULL default '0',
  `spree_kill` mediumint(5) NOT NULL default '0',
  `spree_rampage` mediumint(5) NOT NULL default '0',
  `spree_dom` mediumint(5) NOT NULL default '0',
  `spree_uns` mediumint(5) NOT NULL default '0',
  `spree_god` mediumint(5) NOT NULL default '0',
  `pu_pads` mediumint(5) NOT NULL default '0',
  `pu_armour` mediumint(5) NOT NULL default '0',
  `pu_keg` mediumint(5) NOT NULL default '0',
  `pu_invis` mediumint(5) NOT NULL default '0',
  `pu_belt` mediumint(5) NOT NULL default '0',
  `pu_amp` mediumint(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `name` (`id`,`name`),
  KEY `matchid` (`matchid`,`team`),
  KEY `matchid_2` (`matchid`,`team`,`name`,`gamescore`,`frags`,`deaths`,`suicides`,`teamkills`,`spree_kill`,`spree_rampage`,`spree_dom`,`spree_uns`,`spree_god`,`eff`,`ttl`),
  KEY `matchid_4` (`matchid`,`playerid`,`pu_pads`,`pu_armour`,`pu_keg`,`pu_invis`,`pu_belt`,`pu_amp`),
  KEY `matchid_3` (`matchid`,`team`,`gamescore`,`name`,`flag_taken`,`flag_dropped`,`flag_assist`,`flag_cover`,`flag_seal`,`flag_capture`,`flag_kill`,`flag_return`,`flag_pickedup`),
  KEY `matchid_5` (`matchid`,`name`,`wep_trans`,`wep_insta`,`wep_impact`,`wep_enforcer`,`wep_dblenf`,`wep_bio`,`wep_ripper`,`wep_shock`,`wep_pulse`,`wep_mini`,`wep_flak`,`wep_rock`,`wep_sniper`,`wep_deemer`)
) TYPE=MyISAM AUTO_INCREMENT=27 ;

-- --------------------------------------------------------

-- 
-- Table structure for table `uts_rank`
-- 

CREATE TABLE `uts_rank` (
  `id` mediumint(10) NOT NULL auto_increment,
  `time` varchar(14) NOT NULL default '',
  `name` varchar(50) NOT NULL default '',
  `country` char(2) NOT NULL default '',
  `gamename` varchar(100) NOT NULL default '',
  `rank` float NOT NULL default '0',
  `matches` mediumint(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `name` (`name`,`gamename`)
) TYPE=MyISAM AUTO_INCREMENT=11 ;

-- --------------------------------------------------------

-- 
-- Table structure for table `uts_killsmatrix`
-- 

CREATE TABLE uts_killsmatrix (
	matchid mediumint(8) unsigned NOT NULL default '0',
	killer tinyint(4) NOT NULL default '0',
	victim tinyint(4) NOT NULL default '0',
	kills tinyint(3) unsigned NOT NULL default '0',
	KEY matchid (matchid)
) TYPE=MyISAM;